// ContentsPage.cpp : implementation file
//

#include "stdafx.h"
#include "ITBReader.h"
#include "ContentsPage.h"
#include "LibraryConnection.h"
#include "CommonTypes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CMap<int, int, HANDLE, HANDLE> g_hitemMap;
CONTLINELIST	g_currContentsList;	// It is empty by CLibraryDlg too.
UINT			g_nCurrContBook = 0;

/////////////////////////////////////////////////////////////////////////////
// CContentsPage property page

IMPLEMENT_DYNCREATE(CContentsPage, CPropertyPage)

CContentsPage::CContentsPage() : CPropertyPage(CContentsPage::IDD)
{
	//{{AFX_DATA_INIT(CContentsPage)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CContentsPage::~CContentsPage()
{
}

void CContentsPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CContentsPage)
	DDX_Control(pDX, IDC_TREE, m_treeCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CContentsPage, CPropertyPage)
	//{{AFX_MSG_MAP(CContentsPage)
	ON_NOTIFY(NM_DBLCLK, IDC_TREE, OnDblclkTree)
	ON_NOTIFY(NM_CLICK, IDC_TREE, OnClickTree)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_REQUEST_COMPLETED, OnRequestCompleted)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CContentsPage message handlers
BOOL CContentsPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	int iconos[] = {IDI_OPEN_BOOK, IDI_HEADING1, IDI_HEADING2, IDI_HEADING3, 0};
	int cant = 0;
	
	for (int* ptro = iconos; *ptro != 0; ptro++)
		cant++;

	m_iconos.Create(16, 16, 0/*ILC_COLOR4*/, cant, cant);
	
	for (int* p = iconos; *p != 0; p++) 
		m_iconos.Add((HICON)::LoadImage(
			AfxGetInstanceHandle(), 
			MAKEINTRESOURCE(*p), 
			IMAGE_ICON, 0, 0, 0));
	
	m_treeCtrl.SetImageList(&m_iconos, TVSIL_NORMAL);

	
	REQUESTINFO ri;

	ri.strObjectName.Format(
		TEXT("/ITBLibrary.dll?GetContents?Book=%d"), 
		::GetCurrentBook());
	
	ri.lpszVerb = NULL;
	ri.nReadFuncType = RFT_ASCII;
	ri.hwndRequester = NULL;
	ri.nPage = PAGE_INDEPENDENT;

	UINT code = InternetRequestThreadProc(&ri);

	CString msg;

	if (code == IR_ANSW_404) {
		msg.Format(_T("Library doesn't have the Contents capability"));
		AfxMessageBox(msg);
	}
	else if (code != IR_OK) {
		msg.Format(_T("Error when connect to the library"));
		AfxMessageBox(msg);
	}
	else {
		FillTree((char*)ri.pBuffer);
		delete[] ri.pBuffer;

		HTREEITEM  h = m_treeCtrl.GetNextItem(NULL, TVGN_CHILD);

		if (h) m_treeCtrl.Expand(h, TVE_EXPAND);
	}
	
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CContentsPage::OnClickTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	//m_treeCtrl.Expand(m_treeCtrl.GetSelectedItem(), TVE_TOGGLE);
	
	*pResult = 0;
}

void CContentsPage::OnDblclkTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int nPage = m_treeCtrl.GetItemData(m_treeCtrl.GetSelectedItem());

	AfxGetMainWnd()->PostMessage(WM_GOTO_PAGE, nPage);

	*pResult = 1;
}

LRESULT CContentsPage::OnRequestCompleted(WPARAM wParam, LPARAM lParam)
{
	REQUESTINFO* pRequestInfo = (REQUESTINFO*)lParam;

	if (wParam == TRUE) 
	{
		//delete[] pRequestInfo->pBuffer;
	}

	//delete pRequestInfo;

	return 0L;
}

void CContentsPage::FillTree(char* pBuffer)
{
	TV_INSERTSTRUCT tvi;
	HANDLE hParent;
	CONTLINE cl;

	if (g_currContentsList.IsEmpty() ||
		g_nCurrContBook != ::GetCurrentBook())
	{
		char* p = pBuffer;

		g_currContentsList.RemoveAll();
		g_nCurrContBook = ::GetCurrentBook();

		// Common fiels
		tvi.item.mask = TVIF_IMAGE | /*TVIF_SELECTEDIMAGE | */
			TVIF_TEXT | TVIF_PARAM;
		tvi.hInsertAfter = TVI_LAST;

		while (ParseLine(p, cl.nID, cl.nParentID, cl.strText, cl.nPage))
		{
			if (cl.nParentID == 0 ||
				!g_hitemMap.Lookup(cl.nParentID, hParent))
			{
				tvi.hParent = TVI_ROOT;
				tvi.item.iImage = 0;
				tvi.item.iSelectedImage = 0;
			}
			else {
				tvi.hParent = (HTREEITEM)hParent;
				tvi.item.iImage = 1;
				tvi.item.iSelectedImage = 1;
			}
			
			tvi.item.pszText = cl.strText.GetBuffer(0);
			tvi.item.lParam = cl.nPage;
			
			g_hitemMap.SetAt(cl.nID, m_treeCtrl.InsertItem(&tvi));

			g_currContentsList.AddTail(cl);
		}
	}
	else {
		POSITION pos = g_currContentsList.GetHeadPosition();

		// Common fiels
		tvi.item.mask = TVIF_IMAGE | /*TVIF_SELECTEDIMAGE | */
			TVIF_TEXT | TVIF_PARAM;
		tvi.hInsertAfter = TVI_LAST;

		while (pos)
		{
			cl = g_currContentsList.GetNext(pos);

			if (cl.nParentID == 0 ||
				!g_hitemMap.Lookup(cl.nParentID, hParent))
			{
				tvi.hParent = TVI_ROOT;
				tvi.item.iImage = 0;
				tvi.item.iSelectedImage = 0;
			}
			else {
				tvi.hParent = (HTREEITEM)hParent;
				tvi.item.iImage = 1;
				tvi.item.iSelectedImage = 1;
			}
			
			tvi.item.pszText = cl.strText.GetBuffer(0);
			tvi.item.lParam = cl.nPage;
			
			g_hitemMap.SetAt(cl.nID, m_treeCtrl.InsertItem(&tvi));
		}
	}
	
	g_hitemMap.RemoveAll();
}

char* CContentsPage::ParseLine(char*& p, int& nID, int& nParentID, 
									  CString& strText, int& nPage)
{
	nID = atoi(p);
	p = strchr(p, '\t');
	if (!p) return p;
	
	nParentID = atoi(++p);

	p = strchr(p, '\t');
	if (!p) return p;

	char* pText = ++p;
	p = strchr(p, '\t');
	if (!p) return p;
	*p++ = '\0';

	strText.Format(_T("%hs"), pText);

	nPage = atoi(p);

	p = strchr(p, '\n');
	if (!p) return p;

	return ++p;
}


