// FindPage.cpp : implementation file
//

#include "stdafx.h"
#include "ITBReader.h"
#include "FindPage.h"
#include "LibraryConnection.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFindPage property page

IMPLEMENT_DYNCREATE(CFindPage, CPropertyPage)

CFindPage::CFindPage() : CPropertyPage(CFindPage::IDD)
{
	//{{AFX_DATA_INIT(CFindPage)
	m_bMatchCase = FALSE;
	m_bWholeWordOnly = FALSE;
	m_nRange = -1;
	//}}AFX_DATA_INIT
}

CFindPage::~CFindPage()
{
}

void CFindPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFindPage)
	DDX_Control(pDX, IDC_WORD, m_editCtrl);
	DDX_Check(pDX, IDC_MC_CHECK, m_bMatchCase);
	DDX_Check(pDX, IDC_WWO_CHECK, m_bWholeWordOnly);
	DDX_Radio(pDX, IDC_EB_RADIO, m_nRange);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFindPage, CPropertyPage)
	//{{AFX_MSG_MAP(CFindPage)
	ON_BN_CLICKED(IDC_NEXT, OnNext)
	ON_BN_CLICKED(IDC_PREVIOUS, OnPrevious)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFindPage message handlers

void CFindPage::OnNext() 
{
	CWaitCursor wc;
	
	REQUESTINFO ri;
	CString str, msg;

	m_editCtrl.GetWindowText(str);

	ri.strObjectName.Format(
		TEXT("/ITBLibrary.dll?Find?Book=%d&Page=%d&Text=%s&Range=%d&Case=%d&Word=%d"), 
		::GetCurrentBook(), ::GetCurrentPage(), (LPCTSTR)str, m_nRange, 
		(m_bMatchCase) ? 1:0, (m_bWholeWordOnly) ? 1:0);
	
	ri.lpszVerb = NULL;
	ri.nReadFuncType = RFT_ASCII;
	ri.hwndRequester = NULL;
	ri.nPage = PAGE_INDEPENDENT;

	UINT code = InternetRequestThreadProc(&ri);

	if (code == IR_ANSW_404) {
		msg.Format(_T("Cannot find the string: %s"), (LPCTSTR)str);
		AfxMessageBox(msg);
	}
	else if (code != IR_OK) {
		msg.Format(_T("Error when connect to the library"));
		AfxMessageBox(msg);
	}
	else {
		int nPage = atoi((char*)ri.pBuffer);
		AfxGetMainWnd()->PostMessage(WM_GOTO_PAGE, nPage);
		delete[] ri.pBuffer;
	}
}

void CFindPage::OnPrevious() 
{
	CWaitCursor wc;
	
	REQUESTINFO ri;
	CString str, msg;

	m_editCtrl.GetWindowText(str);

	ri.strObjectName.Format(
		TEXT("/ITBLibrary.dll?Find?Book=%d&Page=%d&Text=%s&Range=%d&Case=%d&Word=%d"), 
		::GetCurrentBook(), ::GetCurrentPage(), (LPCTSTR)str, m_nRange, 
		(m_bMatchCase) ? 1:0, (m_bWholeWordOnly) ? 1:0);
	
	ri.lpszVerb = NULL;
	ri.nReadFuncType = RFT_ASCII;
	ri.hwndRequester = NULL;
	ri.nPage = PAGE_INDEPENDENT;

	UINT code = InternetRequestThreadProc(&ri);

	if (code == IR_ANSW_404) {
		msg.Format(_T("Cannot find the string: %s"), (LPCTSTR)str);
		AfxMessageBox(msg);
	}
	else if (code != IR_OK) {
		msg.Format(_T("Error when connect to the library"));
		AfxMessageBox(msg);
	}
	else {
		int nPage = atoi((char*)ri.pBuffer);
		AfxGetMainWnd()->PostMessage(WM_GOTO_PAGE, nPage);
		delete[] ri.pBuffer;
	}
}
