/*------------------------------------------------
				HTMLParser.cpp
--------------------------------------------------*/
#include "stdafx.h"
#include "HTMLParser.h"

#define X(A)	CHTMLParser::A

/*                                   EOF [0]           Letra [1]        Digito [2]       Blanc [3] < [4]   > [5]      / [6]             */
const int newState[7][7] = {
				   /* Inicial [0] */ {END,             1,               1,               0,        4,      1,         1},
					 /* Texto [1] */ {END,             1,               1,               3,        2,      1,         1},
   /* Posible EndText por Tag [2] */ {END,             END,             END,             3,        2,      1,         END},
	/* Espacios descartados / [3] */ {END,             1,               1,               3,        2,      1,         1},
				/*Posible Tag [4] */ {END,             5,               5,               3,        1,      END,       6},
					   /* Tag [5] */ {END,             5,               5,               5,        5,      END,       5},
					  /* ETag [6] */ {END,             6,               6,               6,        6,      END,       6}};


// Define a pointer to a semantic routine 
typedef int (CHTMLParser::*SRPTR)(TCHAR);

/* Semantic Routines */

/*                                   EOF [0]             Letra [1]        Digito [2]		  Blanc [3] < [4]		> [5]		/ [6]             */
SRPTR CHTMLParser::pfSemRut[7][7] = {
				   /* Inicial [0] */ {X(OnEOF),           X(OnText),        X(OnText),        NULL,      X(OnText), X(OnText),   X(OnText)},
					 /* Texto [1] */ {X(OnEndTextByEOF),  X(OnText),        X(OnText),        X(OnText), X(OnText), X(OnText),   X(OnText)},
   /* Posible EndText por Tag [2] */ {X(OnEndTextByEOF),  X(OnEndTextByTag),X(OnEndTextByTag),X(OnText), X(OnText), X(OnText),   X(OnEndTextByTag)},
	/* Espacios descartados / [3] */ {X(OnEndTextByEOF),  X(OnText),        X(OnText),        NULL,      X(OnText), X(OnText),   X(OnText)},
				/*Posible Tag [4] */ {X(OnEOF),           X(OnTag),         X(OnTag),         X(OnText), X(OnText), X(OnEndTag), X(OnETag)},
					   /* Tag [5] */ {X(OnEOF),           X(OnTag),         X(OnTag),         X(OnTag),  X(OnTag),  X(OnEndTag), X(OnTag)},
					  /* ETag [6] */ {X(OnEOF),           X(OnETag),        X(OnETag),        X(OnETag), X(OnETag), X(OnEndETag),X(OnETag)}};


CHTMLParser::CHTMLParser()
{
	lexBufferLength = 0;
	nLineCount = 0;
	nLineTokenCount = 0;
	bAddNewLine = false;
	nCurrentPos = 0;
	nMaxPos = 0;
}

bool CHTMLParser::Open(LPCTSTR input)
{
	/*ASSERT(in == NULL);
	if((in = fopen(input, _T("rt"))) == NULL) 
	{
		ErrorMessage(_T("Error al abrir el archivo de entrada"));
		return false;
	}*/

	return true;
}

int CHTMLParser::GetNextChar()
{
	if (nCurrentPos >= nMaxPos)
		return WEOF;
	else 
		return in[nCurrentPos++];
}

void CHTMLParser::MoveCharPos(int nOffset)
{
	nCurrentPos += nOffset;
	ASSERT(nCurrentPos >= 0 && nCurrentPos <= nMaxPos);
}

bool CHTMLParser::Open(LPTSTR pBuffer, UINT nBufferSize)
{
	ASSERT(pBuffer != NULL && nBufferSize > 0);
	
	in = pBuffer;
	nCurrentPos = 0;
	nMaxPos = nBufferSize;

	return true;
}

void CHTMLParser::Close()
{
	/*ASSERT(in != NULL);
	fclose(in);
	in = NULL;
	out = NULL;
	lexBufferLength = 0;
	nLineCount = 0;
	nLineTokenCount = 0;
	bAddNewLine = false;*/
}

int CHTMLParser::GetEvent(int c)
{
	if (c == WEOF) return 0;
	if (iswalpha(c) || c == '_') return 1;
	if (iswdigit(c)) return 2;
	
	switch (c) {
		case ' ':
		case '\t':
		case '\v':
		case '\f':
		case '\r':
		case '\n': return 3;
		case '<':  return 4;
		case '>':  return 5;
		case '/':  return 6;
	}
	return 1;
}

int CHTMLParser::GetToken(TOKEN* pToken)
{
	int c, event, state = 0, token;
	SRPTR pf;

	lexBufferLength = 0;

	do {
		//c = fgetc(in);
		c = GetNextChar();
		event = GetEvent(c);

		if (pf = pfSemRut[state][event]) 
			token = (this->*pf)((TCHAR)c);

		state = newState[state][event];

	} while (state != END);

	nLineTokenCount++;

	pToken->id = token;
	pToken->p = lexBuffer;

	return token;
}

void CHTMLParser::ErrorMessage(TCHAR* szMsg)
{
	MessageBox(NULL, szMsg, _T("Error"), MB_OK | MB_ICONERROR);
}

/* Semantic Routines */
int CHTMLParser::GetSpecialChar()
{
	// TODO...
	return '&';
}
// Al leer un prrafo
int CHTMLParser::OnText(TCHAR c)
{
	if (lexBufferLength < MAXLEXBUFFER) {
		if (c == '&')
			c = GetSpecialChar();

 		lexBuffer[lexBufferLength++] = c;
	}
	
	return TK_TEXT;
}

// Al terminar de leer un prrafo
int CHTMLParser::OnEndTextByEOF(TCHAR c)
{
	lexBuffer[lexBufferLength] = '\0';

	return TK_TEXT;
}

// Al leer un <
int CHTMLParser::OnEndTextByTag(TCHAR c)
{
	//it shuldnt cunsume the TCHARacter: ungetc('<', in); and ungetc(c, in);
	//fseek(in, -2, SEEK_CUR);
	MoveCharPos(-2);
	lexBuffer[--lexBufferLength] = '\0';

	return TK_TEXT;
}

// Al leer un tag
int CHTMLParser::OnTag(TCHAR c)
{
	if (lexBufferLength < MAXLEXBUFFER)
 		lexBuffer[lexBufferLength++] = c;
	
	return TK_TAG;
}

// Al terminar de leer un Tag
int CHTMLParser::OnEndTag(TCHAR c)
{
	lexBuffer[lexBufferLength] = '\0';
	TCHAR* sz = lexBuffer + 1;

	if (!_tcsicmp(sz, _T("B"))) return TK_TAG_B;
	else if (!_tcsicmp(sz, _T("I"))) return TK_TAG_I;
	else if (!_tcsicmp(sz, _T("H1"))) return TK_TAG_H1;
	else if (!_tcsicmp(sz, _T("H2"))) return TK_TAG_H2;
	else if (!_tcsicmp(sz, _T("H3"))) return TK_TAG_H3;
	else if (!_tcsicmp(sz, _T("H4"))) return TK_TAG_H4;
	else if (!_tcsicmp(sz, _T("H5"))) return TK_TAG_H5;
	else if (!_tcsicmp(sz, _T("H6"))) return TK_TAG_H6;
	else if (!_tcsicmp(sz, _T("P"))) return TK_TAG_P;
	else if ((*sz == 'A' || *sz == 'a') && (*(sz + 1) == ' ' || *(sz + 1) == '\0'))
		return TK_TAG_A;
	
	return TK_TAG_UNKNOWN;
}

// Al leer un Etag </X>
int CHTMLParser::OnETag(TCHAR c)
{
	if (lexBufferLength < MAXLEXBUFFER)
 		lexBuffer[lexBufferLength++] = c;
	
	return TK_ETAG;
}

// Al terminar de leer un Etag
int CHTMLParser::OnEndETag(TCHAR c)
{
	lexBuffer[lexBufferLength] = '\0';
	TCHAR* sz = lexBuffer + 2;

	if (!_tcsicmp(sz, _T("B"))) return TK_ETAG_B;
	else if (!_tcsicmp(sz, _T("I"))) return TK_ETAG_I;
	else if (!_tcsicmp(sz, _T("H1"))) return TK_ETAG_H1;
	else if (!_tcsicmp(sz, _T("H2"))) return TK_ETAG_H2;
	else if (!_tcsicmp(sz, _T("H3"))) return TK_ETAG_H3;
	else if (!_tcsicmp(sz, _T("H4"))) return TK_ETAG_H4;
	else if (!_tcsicmp(sz, _T("H5"))) return TK_ETAG_H5;
	else if (!_tcsicmp(sz, _T("H6"))) return TK_ETAG_H6;
	else if (!_tcsicmp(sz, _T("P"))) return TK_ETAG_P;
	else if (!_tcsicmp(sz, _T("A"))) return TK_ETAG_A;
	
	return TK_ETAG_UNKNOWN;
}

// Al leer un End Of File
int CHTMLParser::OnEOF(TCHAR c)
{
	//Unespected EOF
	return TK_EOF;
}

