// HTMLTextView.cpp : implementation of the CHTMLTextView class
//

#include "stdafx.h"
#include "ITBReader.h"
#include "LibraryConnection.h"

#include "HTMLTextDoc.h"
#include "HTMLTextView.h"
#include "MainFrm.h"

#include "TextLineParser.h"

/*extern "C" {
	#include <htmlctrl.h>
}*/

#define PAGEREQUEST			1
#define HIGHTEXTREQUEST		2

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHTMLTextView

IMPLEMENT_DYNCREATE(CHTMLTextView, CHTMLView)

BEGIN_MESSAGE_MAP(CHTMLTextView, CHTMLView)
	//{{AFX_MSG_MAP(CHTMLTextView)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_REQUEST_COMPLETED, OnRequestCompleted)
	ON_MESSAGE(WM_SAVE_CONTENTS, OnSaveContents)
END_MESSAGE_MAP()

//ON_NOTIFY(NM_HOTSPOT, IDC_HTMLVIEW, OnLink)

/////////////////////////////////////////////////////////////////////////////
// CHTMLTextView construction/destruction

#define DISPLAYCLASS  TEXT("DISPLAYCLASS")

//BOOL g_bMakeFit = TRUE;		// DTM_ENABLESHRINK Shrink-enable flag
//TCHAR const c_szHTMLControlLibrary[] = TEXT("htmlview.dll");

// Es necesario linkear htmlview.lib WININETM.LIB COMMDLGM.LIB 

CHTMLTextView::CHTMLTextView()
{
	// Load the HTML Viewer Control DLL (Htmlview.dll)
	//m_hInstHTMLCtrl = LoadLibrary(c_szHTMLControlLibrary);
	
	// Initialize the HTML Viewer Control.
	//InitHTMLControl(AfxGetInstanceHandle());

	m_pPageRequestThread = NULL;
	m_pHighTextRequestThread = NULL;
	m_bPageArrived = false;
	m_nCurrBook = 0;	// Known value
	m_nCurrPage = PAGE_INDEPENDENT;
}

CHTMLTextView::~CHTMLTextView()
{
}

BOOL CHTMLTextView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CHTMLView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CHTMLTextView drawing

void CHTMLTextView::OnDraw(CDC* pDC)
{
	CHTMLView::OnDraw(pDC);
}

void CHTMLTextView::OnInitialUpdate()
{
	CHTMLView::OnInitialUpdate();
}

/////////////////////////////////////////////////////////////////////////////
// CHTMLTextView diagnostics

#ifdef _DEBUG
void CHTMLTextView::AssertValid() const
{
	CHTMLView::AssertValid();
}

void CHTMLTextView::Dump(CDumpContext& dc) const
{
	CHTMLView::Dump(dc);
}

CHTMLTextDoc* CHTMLTextView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CHTMLTextDoc)));
	return (CHTMLTextDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CHTMLTextView message handlers

BOOL CHTMLTextView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	if(!CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext))
		return FALSE;

	//m_hwndHtml = ::CreateWindow(DISPLAYCLASS, NULL,
	//	WS_CHILD /*| WS_VISIBLE*/ | WS_CLIPSIBLINGS,
	//	0, 0, 300, 200,
	//	GetSafeHwnd(), (HMENU)IDC_HTMLVIEW, AfxGetInstanceHandle(), NULL);			
	//if (m_hwndHtml == NULL) 
	//	return FALSE;
	//::SetFocus(m_hwndHtml);
	//::PostMessage(m_hwndHtml, DTM_ENABLESHRINK, 0, TRUE);

	return TRUE;
}

void CHTMLTextView::OnSize(UINT nType, int cx, int cy) 
{
	CHTMLView::OnSize(nType, cx, cy);
	
	if (::IsWindow(m_hwndHtml))
		::MoveWindow(m_hwndHtml, 0, 0, cx, cy, FALSE);	
}

void CHTMLTextView::OnUpdate(CView* pSender, LPARAM lPageNumber, CObject* pHint) 
{	
	if (pHint == NULL) return;	// => MFC default update
	
	// Save previous changes
	if (!OnSaveContents(0,0) && AfxMessageBox(IDS_ERROR_SAVE_HIGHTEXT,
		MB_ICONERROR | MB_YESNO | MB_DEFBUTTON2) == IDNO)
		return;
	
	REQUESTINFO* pRequestInfo = new REQUESTINFO;
	if (!pRequestInfo) return;

	// Ask for text
	pRequestInfo->strObjectName.Format(
		TEXT("/ITBLibrary.dll?GetPage?Book=%d&Page=%d"), 
		::GetCurrentBook(), lPageNumber);
	
	pRequestInfo->lpszVerb = NULL;
	pRequestInfo->nReadFuncType = RFT_ASCII;
	pRequestInfo->hwndRequester = GetSafeHwnd();
	pRequestInfo->nPage = (int)lPageNumber;
	pRequestInfo->uBook = ::GetCurrentBook();
	pRequestInfo->nRequestCode = PAGEREQUEST;

	m_bPageArrived = false; // It may cause some interthread problem when turning true.
							// Fix it someday.

	m_pPageRequestThread = 
		AfxBeginThread(InternetRequestThreadProc, pRequestInfo);
	
	// Ask for highlighted text
	pRequestInfo = new REQUESTINFO;

	pRequestInfo->strObjectName.Format(
		_T("/ITBLibrary.dll?GetHighlightedText?UserName=%s&Password=%s&Book=%d&Page=%d"), 
		GetITBUsrName(), GetITBUsrPsw(), ::GetCurrentBook(), lPageNumber);
	
	pRequestInfo->lpszVerb = NULL;
	pRequestInfo->nReadFuncType = RFT_ASCII;
	pRequestInfo->hwndRequester = GetSafeHwnd();
	pRequestInfo->nPage = (int)lPageNumber;
	pRequestInfo->uBook = ::GetCurrentBook();
	pRequestInfo->nRequestCode = HIGHTEXTREQUEST;

	m_pHighTextRequestThread = 
		AfxBeginThread(InternetRequestThreadProc, pRequestInfo);
}

LRESULT CHTMLTextView::OnRequestCompleted(WPARAM wParam, LPARAM lParam)
{
	REQUESTINFO* pRequestInfo = (REQUESTINFO*)lParam;

	if (wParam == TRUE) 
	{
		ASSERT(pRequestInfo->pBuffer);

		if (!IsInvalidPage(pRequestInfo->nPage, pRequestInfo->uBook)) 
		{
			/*::SendMessage(m_hwndHtml, WM_SETTEXT, 0,(LPARAM)(LPCTSTR)"");	// Clear text
			::SendMessage(m_hwndHtml, DTM_ADDTEXT, (WPARAM)(BOOL) FALSE, 
				(LPARAM) pRequestInfo->pBuffer);
			::SendMessage(m_hwndHtml, DTM_ENDOFSOURCE, 0, 0);*/
			
			if (pRequestInfo->nRequestCode == PAGEREQUEST) /*AfxGetThread() == m_pPageRequestThread*/
			{	
				CString str;
				str.Format(_T("%hs"), pRequestInfo->pBuffer);
				str.TrimRight();
				
				DWORD dwSize = str.GetLength();
				
				SetHTMLText(str.GetBuffer(0), dwSize);
				m_bPageArrived = true; // Now high. text can be displayed

				str.ReleaseBuffer(dwSize);

				// It must no be here !!!!!!!!!!!!!!!!!!!!!!!!!!!!
				m_nCurrBook = ::GetCurrentBook();
				m_nCurrPage = ::GetCurrentPage();
			}
			else if(pRequestInfo->nRequestCode == HIGHTEXTREQUEST)
			{
				CTextLineParser parser;
				TLP_FORMAT pFormat[] = {TLP_INT, TLP_INT, TLP_ZSTR};
				TLP_TYPE1 parms;
				char* p = (char*)pRequestInfo->pBuffer;
				bool bInvalidate = false;

				parser.SetFormat(pFormat, sizeof(pFormat) / sizeof(TLP_FORMAT), ',');

				while(p)
					if(parser.ParseTextLine(&p, &parms))
					{
						AddHighlight(parms.nParam1, parms.nParam2, 
							RGB(255, 255, 0), parms.szParam3);
						bInvalidate = true;
					}

				if(bInvalidate && m_bPageArrived) Invalidate();
			}
			else ASSERT(false);
		}

		delete[] pRequestInfo->pBuffer;
	}

	delete pRequestInfo;

	return 0L;
}

void CHTMLTextView::OnLink(NMHDR* pNotifyStruct, LRESULT* result)
{
	AfxMessageBox(TEXT("OnLink"));
}

void CHTMLTextView::OnLink(CString strData)
{
	LPCTSTR p = (LPCTSTR) strData;

	for (; *p == ' '; p++)
		if (*p == '\0') return;

	if (_tcsnicmp(p, _T("href"), 4)) return;

	for (p += 4; *p == ' '; p++)
		if (*p == '\0') return;

	if (*p != '=') return;

	for (++p; *p == ' '; p++)
		if (*p == '\0') return;

	if (!_tcsnicmp(p, _T("picture"), 7))
	{
		int pic = _ttoi(p + 7);
		AfxGetMainWnd()->SendMessage(WM_PUSH_PICTURE, pic);
	}
	else if (!_tcsnicmp(p, _T("page"), 4))
	{
		int page = _ttoi(p + 4);
		int book = 0;

		p = _tcschr(p, '.');
		if (p && !_tcsnicmp(++p, _T("book"), 4))
			book = _ttoi(p + 4);

		AfxGetMainWnd()->SendMessage(WM_GOTO_PAGE, page, book);
	}
}

LRESULT CHTMLTextView::OnSaveContents(WPARAM wParam, LPARAM lParam)
{
	if (!IsModified())
		return TRUE;

	ASSERT(m_nCurrPage != PAGE_INDEPENDENT);

	POSITION pos = GetFirstHighlightPosition();
	HIGHLIGHT ht;
	CString strAux, strSend;

	while (pos) {
		ht = GetNextHighlight(pos);
		strAux.Format("%d,%d,%s@@", ht.nFirstChar, ht.nLastChar, "");
		strSend += strAux;
	}
	strSend += "\r\n";

	CWaitCursor wc;
	REQUESTINFO ri;					//Warning: It couldn't be user a new thread argument!
	
	ri.strObjectName.Format(
		_T("/ITBLibrary.dll?SetHighlightedText?UserName=%s&Password=%s&Book=%d&Page=%d"),
		GetITBUsrName(), GetITBUsrPsw(), m_nCurrBook, m_nCurrPage);

	ri.lpszVerb = _T("POST");
	ri.nReadFuncType = RFT_VOID;
	ri.hwndRequester = NULL;		// I don't want to any response message
	ri.dwBufferSize = strSend.GetLength();
	ri.pBuffer = (BYTE*)strSend.GetBuffer(0);
	ri.nPage = PAGE_INDEPENDENT;	// It shouldn't finish if the current page change
		
	// It should'n be a thread like AfxBeginThread(InternetRequestThreadProc, pRequestInfo);
	if(InternetRequestThreadProc(&ri) != IR_OK)
		return FALSE;

	SetModifiedFlag(false);

	return TRUE;
}
