// IndexPage.cpp : implementation file
//

#include "stdafx.h"
#include "ITBReader.h"
#include "IndexPage.h"
#include "LibraryConnection.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

char g_text2[] = "Pepe\t40\n"
"Juan\t340\tchap1\tcontext\n"
"Final\t4";

/////////////////////////////////////////////////////////////////////////////
// CIndexPage property page

IMPLEMENT_DYNCREATE(CIndexPage, CPropertyPage)

CIndexPage::CIndexPage() : CPropertyPage(CIndexPage::IDD)
{
	//{{AFX_DATA_INIT(CIndexPage)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CIndexPage::~CIndexPage()
{
}

void CIndexPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIndexPage)
	DDX_Control(pDX, IDC_WORD, m_editCtrl);
	DDX_Control(pDX, IDC_WORD_LIST, m_listCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CIndexPage, CPropertyPage)
	//{{AFX_MSG_MAP(CIndexPage)
	ON_BN_CLICKED(IDC_FIND, OnFind)
	ON_BN_CLICKED(IDC_DISPLAY, OnDisplay)
	ON_NOTIFY(NM_DBLCLK, IDC_WORD_LIST, OnDblclkWordList)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_REQUEST_COMPLETED, OnRequestCompleted)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIndexPage message handlers

BOOL CIndexPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

	m_listCtrl.InsertColumn(0, TEXT("Word"), LVCFMT_LEFT, 80);
	m_listCtrl.InsertColumn(1, TEXT("Chapter"), LVCFMT_CENTER, 60);
	m_listCtrl.InsertColumn(2, TEXT("Context"), LVCFMT_LEFT, 280);
	
	OnRequestCompleted(TRUE, TRUE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CIndexPage::OnFind() 
{
	CWaitCursor wc;
	
	REQUESTINFO ri;
	CString str, msg;

	m_editCtrl.GetWindowText(str);

	REQUESTINFO* pRequestInfo = new REQUESTINFO;
	if (!pRequestInfo) return;

	pRequestInfo->strObjectName.Format(
		TEXT("/ITBLibrary.dll?GetIndexWord?Book=%d&Text=%s"), 
		::GetCurrentBook(), (LPCTSTR)str);
	
	pRequestInfo->lpszVerb = NULL;
	pRequestInfo->nReadFuncType = RFT_ASCII;
	pRequestInfo->hwndRequester = NULL;
	pRequestInfo->nPage = PAGE_INDEPENDENT;

	UINT code = InternetRequestThreadProc(pRequestInfo);

	if (code == IR_ANSW_404) {
		msg.Format(_T("Cannot find the string: %s"), (LPCTSTR)str);
		AfxMessageBox(msg);
	}
	else if (code != IR_OK) {
		msg.Format(_T("Error when connect to the library"));
		AfxMessageBox(msg);
	}
	else {
		OnRequestCompleted(TRUE, (LPARAM)ri.pBuffer);
	}
}

void CIndexPage::OnDisplay() 
{
	int i = m_listCtrl.GetNextItem(-1, LVNI_SELECTED);
	if (i == -1) return;

	AfxGetMainWnd()->PostMessage(WM_GOTO_PAGE, 
		m_listCtrl.GetItemData(i));
	
}

LRESULT CIndexPage::OnRequestCompleted(WPARAM wParam, LPARAM lParam)
{
	REQUESTINFO* pRequestInfo = (REQUESTINFO*)lParam;

	if (wParam == TRUE) 
	{
		LV_ITEM item;
		char* p = g_text2;
		CString strWord, strChapter, strContext;
		int nPage, i = 0, index;
 

		while (ParseLine(p, strWord, nPage, strChapter, strContext))
		{
			item.mask = LVIF_TEXT | LVIF_PARAM; 
			item.iItem = 0;
			item.iSubItem = 0;
			item.pszText = strWord.GetBuffer(0);
			item.lParam = nPage;
			
			index = m_listCtrl.InsertItem(&item);

			item.mask = LVIF_TEXT;
				
			item.iItem = index;
			item.iSubItem = 1;
			item.pszText = strChapter.GetBuffer(0);;
			m_listCtrl.SetItem(&item);
				
			item.iItem = index;
			item.iSubItem = 2;
			item.pszText = strContext.GetBuffer(0);;
			m_listCtrl.SetItem(&item);
		}
		//delete[] pRequestInfo->pBuffer;
	}

	//delete pRequestInfo;

	return 0L;
}

bool CIndexPage::ParseLine(char*& p, CString& strWord, int& nPage, 
							CString& strChapter, CString& strContext)
{
	if (!p) return false;

	char* pText = p;
	strChapter.Empty();
	strContext.Empty();

	p = strchr(p, '\t');
	if (!p) return false;
	
	*p++ = '\0';
	strWord.Format(_T("%hs"), pText);

	nPage = atoi(p);
	
	// Optional fields
	char* p2 = p;
	if (!(p = strchr(p, '\n')) && !(p = strchr(p2, '\t')))
		return true;

	if (*p++ != '\t') 
		return true;

	pText = p;

	p2 = p;
	if (!(p = strchr(p, '\n')) && !(p = strchr(p2, '\t')))
	{
		strChapter.Format(_T("%hs"), pText);
		return true;
	}
	else if (*p == '\n') {
		*p++ = '\0';
		strChapter.Format(_T("%hs"), pText);
		return true;
	}

	*p++ = '\0';
	strChapter.Format(_T("%hs"), pText);

	pText = p;

	p2 = p;
	if (!(p = strchr(p, '\n')) && !(p = strchr(p2, '\t')))
	{
		strContext.Format(_T("%hs"), pText);
		return true;
	}
	else if (*p == '\n') {
		*p++ = '\0';
		strContext.Format(_T("%hs"), pText);
		return true;
	}
	
	*p++ = '\0';
	strContext.Format(_T("%hs"), pText);

	return true;
}

void CIndexPage::OnDblclkWordList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OnDisplay();
	
	*pResult = 0;
}
