// LibraryConnection.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// Data structures and constants

#define HTMLBUFF 1024

#define LIBRARY_PAGE			-1
#define	PAGE_INDEPENDENT		-2

#define IR_OK					0
#define IR_ERROR_DEFAULT		1
#define IR_ERROR_OPEN			2
#define IR_ERROR_SEND_POST		3
#define IR_ERROR_SEND_GET		4
#define IR_ERROR_RFT			5
#define IR_ERROR_QUERY_INFO		6
#define IR_ERROR_ANSW_UNK		7
#define IR_ANSW_404				404

enum READFUNCTYPE {RFT_VOID, RFT_ASCII, RFT_DIB};

#ifdef _DEBUG
extern int g_RICount;	// This count should be 0 at the end of execution
#endif

struct REQUESTINFO
{
	LPCTSTR			lpszVerb;		// NULL => GET
	CString			strObjectName; // e.g. TEXT("/custom")
	READFUNCTYPE	nReadFuncType;	// See above
	BYTE*			pBuffer;		// Calleer alloc it & Caller should free it
	DWORD			dwBufferSize;
	HWND			hwndRequester;	// The window who makes the request
	UINT			uBook;
	int				nPage;			// Associate page number or PAGE_INDEPENDENT constant
	int				nRequestCode;	// User by requester if needed to have different types of requests
	//HWND	hwndStatus;
#ifdef _DEBUG	
	REQUESTINFO() {g_RICount++;}
	~REQUESTINFO() {g_RICount--;}
#endif
};

struct DIBINFO
{
	LPBITMAPINFOHEADER	lpBMIH;
	LPBYTE				lpImage;
	HBITMAP				hDIBSection;

	DIBINFO() 
	{	
		lpBMIH = NULL;
		lpImage = NULL;
		hDIBSection = NULL; 
	}
	~DIBINFO()
	{
		if (lpBMIH) delete[] ((char*)lpBMIH);
		if (hDIBSection) ::DeleteObject(hDIBSection); // This deletes lpImage too
	}
};

/////////////////////////////////////////////////////////////////////////////
// Function prototipes

extern UINT InternetConnectionThreadProc(LPVOID pParam);
extern void InternetDisconnect();
extern UINT InternetRequestThreadProc(LPVOID pParam);

/////////////////////////////////////////////////////////////////////////////
// Macros
#define IsInvalidPage(page, book)	\
	(page != PAGE_INDEPENDENT && (page != g_nCurrentPage || book != g_uBookID)) 

/////////////////////////////////////////////////////////////////////////////
// helper inline functions
inline void UnicodeToASCII(LPCTSTR pSrc, char* pDest)
{
	while((*pDest = *((char*)pSrc)) != '\0') {
		pDest++;
		pSrc++;
	}
}

/////////////////////////////////////////////////////////////////////////////
// Window messages

#define WM_REQUEST_COMPLETED WM_USER + 6
