// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__6AC1982D_7F66_11D3_AEB2_B4BA69000000__INCLUDED_)
#define AFX_MAINFRM_H__6AC1982D_7F66_11D3_AEB2_B4BA69000000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CMainFrame : public CFrameWnd
{
	
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
protected:
	CSplitterWnd m_wndMainSplitter;
	CSplitterWnd m_wndNestedSplitter;
	CComboBox m_pageCB;
	HWND m_hPageCBEdit;
	int m_nNoteViewHeight;

public:

// Operations
protected:
	void UpdatePageNumberText();

public:
	int ParseComboBoxText(TCHAR* szString);
	void ShowNoteView(bool bShow = true);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL DestroyWindow();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnLibraryConnection();
	afx_msg void OnNextPage();
	afx_msg void OnPrevPage();
	afx_msg void OnMainSheet();
	afx_msg void OnPrint();
	afx_msg void OnEditFind();
	afx_msg void OnViewContents();
	afx_msg void OnViewIndex();
	afx_msg void OnFilePrintContentsSetup();
	afx_msg void OnViewBookInfo();
	afx_msg void OnFileSaveEx();
	afx_msg void OnFileHomepage();
	afx_msg void OnToggleNote();
	afx_msg void OnUpdateToggleNote(CCmdUI* pCmdUI);
	afx_msg void OnViewAuthorInfo();
	afx_msg void OnClose();
	//}}AFX_MSG
	afx_msg void OnSelChangePageCombobox();
	afx_msg LRESULT OnConnect(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnGoToPage(WPARAM wParam, LPARAM lParam = 0L);
	afx_msg LRESULT OnNoteClick(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnAddNote(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnDeleteNote(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnPushPicture(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnPostCreateClient(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__6AC1982D_7F66_11D3_AEB2_B4BA69000000__INCLUDED_)
