// NoteView.cpp : implementation file
//

#include "stdafx.h"
#include "ITBReader.h"
#include "LibraryConnection.h"
#include "NoteView.h"
 

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNoteView

IMPLEMENT_DYNCREATE(CNoteView, CView)

CNoteView::CNoteView()
{
	m_currNote.nPage = PAGE_INDEPENDENT;
	m_bAddNewNote = false;
}

CNoteView::~CNoteView()
{
}


BEGIN_MESSAGE_MAP(CNoteView, CView)
	//{{AFX_MSG_MAP(CNoteView)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_REQUEST_COMPLETED, OnRequestCompleted)
	ON_MESSAGE(WM_NOTE_CLICK, OnNoteClick)
	ON_MESSAGE(WM_ADD_NOTE, OnAddNote)
	ON_MESSAGE(WM_DELETE_NOTE, OnDeleteNote)
	ON_MESSAGE(WM_SAVE_CONTENTS, OnSaveContents)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNoteView drawing

void CNoteView::OnDraw(CDC* pDC)
{
	//CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CNoteView diagnostics

#ifdef _DEBUG
void CNoteView::AssertValid() const
{
	CView::AssertValid();
}

void CNoteView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CNoteView message handlers

void CNoteView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	if (::IsWindow(m_wndEdit.m_hWnd)) {
		m_wndEdit.MoveWindow(0, 0, cx, cy);
		CRect rc(5, 5, cx - 10, cy);
		m_wndEdit.SetRect(rc);
	}	
}

BOOL CNoteView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	if (!CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext))
		return FALSE;

	return m_wndEdit.Create(ES_AUTOVSCROLL | ES_LEFT | ES_MULTILINE |
		WS_VISIBLE | WS_CHILD | WS_VSCROLL, CRect(0,0,50,50), 
		this, IDC_NOTE_EDIT);
}

void CNoteView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	
	m_wndEdit.SetReadOnly();
}

void CNoteView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if (pHint != NULL) {
		m_wndEdit.SetWindowText(_T(""));
		m_wndEdit.SetReadOnly();
	}
}

LRESULT CNoteView::OnAddNote(WPARAM wNoteKey, LPARAM lParam)
{
	if (!OnSaveContents(0,0) && AfxMessageBox(IDS_ERROR_SAVE_NOTE,
		MB_ICONERROR | MB_YESNO | MB_DEFBUTTON2) == IDNO)
		return FALSE;
	
	m_bAddNewNote = true;
	
	m_currNote = *((NOTEKEY*)wNoteKey);

	m_wndEdit.SetWindowText(_T(""));
	m_wndEdit.SetReadOnly(FALSE);
	
	return TRUE;
}

LRESULT CNoteView::OnDeleteNote(WPARAM wNoteKey, LPARAM lParam)
{
	NOTEKEY* pNote = (NOTEKEY*)wNoteKey;

	CWaitCursor wc;
	REQUESTINFO ri;					//Warning: It couldn't be user a new thread argument!

	ri.strObjectName.Format(
			_T("/ITBLibrary.dll?DeleteNote?UserName=%s&Password=%s&Book=%d&Page=%d&Index=%d"),
			GetITBUsrName(), GetITBUsrPsw(), 
			pNote->nBook, pNote->nPage, pNote->nIndex);
	
	ri.lpszVerb = NULL;
	ri.nReadFuncType = RFT_VOID;
	ri.hwndRequester = NULL;		// I don't want to any response message
	ri.nPage = PAGE_INDEPENDENT;	// It shouldn't finish if the current page change
	
	if (InternetRequestThreadProc(&ri) != IR_OK) {
		AfxMessageBox(IDS_ERROR_DELETE_NOTE);
		return FALSE;
	}

	if (m_currNote == *pNote) 
	{
		m_currNote.nPage = PAGE_INDEPENDENT;
		m_wndEdit.SetWindowText(_T(""));
		m_wndEdit.SetReadOnly();
	}

	return TRUE;
}

LRESULT CNoteView::OnNoteClick(WPARAM wNoteKey, LPARAM lParam)
{
	NOTEKEY* pNote = (NOTEKEY*)wNoteKey;

	if (m_currNote == *pNote) return TRUE;

	if (!OnSaveContents(0,0) && AfxMessageBox(IDS_ERROR_SAVE_NOTE,
		MB_ICONERROR | MB_YESNO | MB_DEFBUTTON2) == IDNO)
		return FALSE;

	CWaitCursor wc;
	REQUESTINFO ri;					//Warning: It couldn't be user a new thread argument!

	ri.strObjectName.Format(
			_T("/ITBLibrary.dll?GetNote?UserName=%s&Password=%s&Book=%d&Page=%d&Index=%d"),
			GetITBUsrName(), GetITBUsrPsw(), 
			pNote->nBook, pNote->nPage, pNote->nIndex);
	
	ri.lpszVerb = NULL;
	ri.nReadFuncType = RFT_ASCII;
	ri.hwndRequester = NULL;		// I don't want to any response message
	ri.nPage = PAGE_INDEPENDENT;	// It shouldn't finish if the current page change
	
	if (InternetRequestThreadProc(&ri) != IR_OK) {
		AfxMessageBox(IDS_ERROR_GET_NOTE);
		return FALSE;
	}

	ASSERT(ri.pBuffer);
	CString str;
	str.Format(_T("%hs"), ri.pBuffer);
	delete[] ri.pBuffer;
	
	m_currNote = *pNote;
	m_wndEdit.SetWindowText(str);
	m_wndEdit.SetReadOnly(FALSE);

	return TRUE;
}

LRESULT CNoteView::OnRequestCompleted(WPARAM wParam, LPARAM lParam)
{
	/*REQUESTINFO* pRequestInfo = (REQUESTINFO*)lParam;

	if (wParam == TRUE) 
	{
		ASSERT(pRequestInfo->pBuffer);
		ASSERT(pRequestInfo->dwBufferSize > 0);

		CString str;
		str.Format(_T("%hs"), pRequestInfo->pBuffer);
		m_wndEdit.SetWindowText(str);

		delete[] pRequestInfo->pBuffer;
	}

	delete pRequestInfo;*/

	return 0L;
}

LRESULT CNoteView::OnSaveContents(WPARAM wParam, LPARAM lParam)
{
	// If the current note was modified, its changes should be
	// stored in the server.
	if (!m_wndEdit.GetModify() ||
		m_currNote.nPage == PAGE_INDEPENDENT) 
		return TRUE;

	CString str;

	m_wndEdit.GetWindowText(str);
	
	if (str.GetLength() <= 0)
		return OnDeleteNote((WPARAM)&m_currNote, 0);

	CWaitCursor wc;
	REQUESTINFO ri;					//Warning: It couldn't be user a new thread argument!
	
	ri.strObjectName.Format(
		_T("/ITBLibrary.dll?%s?UserName=%s&Password=%s&Book=%d&Page=%d&Index=%d"),
		(m_bAddNewNote) ? _T("AddNote"):_T("ReplaceNote"),
		GetITBUsrName(), GetITBUsrPsw(), 
		m_currNote.nBook, m_currNote.nPage, m_currNote.nIndex);

	ri.lpszVerb = _T("POST");
	ri.nReadFuncType = RFT_VOID;
	ri.hwndRequester = NULL;		// I don't want to any response message
	ri.dwBufferSize = str.GetLength();
	ri.pBuffer = (BYTE*)str.GetBuffer(0);
	ri.nPage = PAGE_INDEPENDENT;	// It shouldn't finish if the current page change
		
	// It should'n be a thread like AfxBeginThread(InternetRequestThreadProc, pRequestInfo);
	if(InternetRequestThreadProc(&ri) != IR_OK)
		return FALSE;

	if (m_bAddNewNote) m_bAddNewNote = false;	
	m_wndEdit.SetModify(FALSE);

	return TRUE;
}
