// tokeninfo.h

#define TI_TEXT			0		//0
#define TI_BOLD			2		//1
#define TI_ITALIC		4		//2
#define TI_UNDERLINE	8		//3
#define TI_H1			16		//4
#define TI_H2			32		//5
#define TI_H3			64		//6
#define TI_H4			128		//7
#define TI_H5			256		//8
#define TI_H6			512		//9
#define TI_MATH			1024	//10
#define TI_USERFONT		2048	//11
#define TI_NEWLINE		4096	//12
#define TI_HYPERLINK	8192	//13
#define TI_DATAOWNER	16384	//14

class CTokenInfo 
{
public:
	TCHAR* m_pText;
	int*  m_pWidths;
	int   m_nHeight;
	int   m_nLen;
	int   m_nStyle;
	TCHAR* m_szData;

public:
	CTokenInfo()
	{
		m_pText = NULL;
		m_pWidths = NULL;
		m_nHeight = 0;
		m_nLen = 0;
		m_nStyle = 0;
		m_szData = NULL;
	}
	void SetText(const TCHAR* sz, bool bAddWhiteSpace = false) 
	{
		static bool bAddNextTime = false;
		// override the previous string if were
		// someone must delete it somewhere
		ASSERT(sz != NULL);
		m_nLen = _tcslen(sz);

		if (bAddWhiteSpace && bAddNextTime) {
			m_pText = new TCHAR[m_nLen + 1]; 
			*m_pText = ' ';
			memcpy(m_pText + 1, sz, m_nLen * sizeof(TCHAR));
			m_nLen++;
		}
		else {
			m_pText = new TCHAR[m_nLen]; 
			memcpy(m_pText, sz, m_nLen * sizeof(TCHAR));
		}

		bAddNextTime = ((m_nStyle & TI_NEWLINE) ||
			m_pText[m_nLen - 1] == ' ') ? false:true;
	}

	void SetData(const TCHAR* sz) 
	{
		// override the previous string if were
		// someone must delete it somewhere
		ASSERT(sz != NULL);
		int nLen = _tcslen(sz) + 1 /* '\0' */;

		m_szData = new TCHAR[nLen]; 
		memcpy(m_szData, sz, nLen * sizeof(TCHAR));
		
		m_nStyle |= TI_DATAOWNER;
	}

	void Empty() 
	{
		if (m_pText) delete[] m_pText;
		if (m_pWidths) delete[] m_pWidths;
		if ((m_nStyle & TI_DATAOWNER) && 
			m_szData) delete[] m_szData;
		m_nLen = 0;
		m_nStyle = 0;
	}
};